all: test1

exercise_05_28: exercise_05_28.o | .gitignore
	g++ -Wall -Wextra -Werror -g3  $^  -o  $@

%.ii: %.cpp
	g++ -E  -Wall -Wextra -Werror -g3  $<  -o $@

%.s: %.ii
	g++ -S -Wall -Wextra -Werror -g3 $<  -o $@

%.o: %.s
	g++ -c -Wall -Wextra -Werror -g3 $<  -o $@

.gitignore:
	echo exercise_05_28 > $@

clean:
	rm -f *.ii *.s *.o *.out exercise_05_28 .gitignore

test%: exercise_05_28
	./exercise_05_28 < $@.in > $@.out || echo "Test 1 is executing..."
	diff $@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: exercise_05_28.ii exercise_05_28.ii exercise_05_28.s exercise_05_28.s
.SECONDARY: exercise_05_28.ii exercise_05_28.ii exercise_05_28.s exercise_05_28.s

